/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;

import net.sf.jasperreports.engine.JRDefaultScriptlet;
import net.sf.jasperreports.engine.JRScriptletException;
import net.sf.jasperreports.renderers.JCommonDrawableRenderer;

import org.jfree.chart.JFreeChart;

public class TestWithBugs extends JRDefaultScriptlet{

	private Connection dbConnection;
	private PreparedStatement stmt = null;
	private PreparedStatement stmt2 = null;
	private ResultSet rs = null;
	private ReportUtilities ru;
	private String parArea="";
	private String parProject="";
	private String parCustomer="";
	private String parMethod="";

	private final int idKPI = 18;


	public void afterReportInit() throws JRScriptletException {

		try {
			// get db connection
			dbConnection = (Connection) this.getParameterValue("REPORT_CONNECTION");

			ru=new ReportUtilities(dbConnection); 

			// set idKPI


			// get meterChart value
			BigDecimal value = this.calculateValue(idKPI);

			// calculate kpi threshold
			int thresholdType = 0;
			int idUser = 0;
			int idThreshold = ru.calculateThreshold(thresholdType, idUser,idKPI);

			// get meterChart title
			String title =""; 
				title=ru.getKPITitle(idKPI);
			ArrayList<Pair> subs=new ArrayList<Pair>();
				subs=ru.getSubtitles(parArea, parProject, parCustomer, parMethod);
			// create meter chart
			JFreeChart meterchart = ru.createMeterChart(value, title, idThreshold, subs);
			this.setVariableValue("Chart_meter", new JCommonDrawableRenderer(
					meterchart));

		} catch (Exception e) {
			throw new JRScriptletException(e);
		}
	}

	private BigDecimal calculateValue(int pIdKPI) throws JRScriptletException {
		BigDecimal testWithBugs=new BigDecimal(0);
		BigDecimal testExec=new BigDecimal(0);
		BigDecimal totalValue=new BigDecimal(0);
		try {

			parArea = (String) this.getParameterValue("AreaPar");

			parProject = (String) this.getParameterValue("ProjectPar");
			parCustomer= (String) this.getParameterValue("CustomerPar");
			parMethod= (String) this.getParameterValue("MethodPar");

			String closure="";

			closure+=ru.buildProfile(parArea, parProject, "p", "p");
			closure+=ru.buildCustomerMethod(parCustomer, parMethod, "p", "p");

			String query = "select count(distinct ft.test_case) as TestWithBugs" +
					" from ft_bug ft, dt_project_structure_level3 as p3, " +
					" dt_project_structure_level2 as p2, dt_project_structure_level1 as p1, " +
					" dt_project as p" +
					" where ft.id_project_structure_level3 = p3.id_level3" +
					" and p3.id_level2 = p2.id_level2" +
					" and p2.id_level1 = p1.id_level1" +
					" and p1.id_level1 = p.id_project" +
					" and ft.id_end_time = -1"+closure;

			String query2="select count(distinct id_test_case) as TestExec" +
					" from ft_test ft, dt_project_structure_level3 as p3," +
					" dt_project_structure_level2 as p2, dt_project_structure_level1 as p1," +
					" dt_project as p" +
					" where ft.id_project_structure_level3 = p3.id_level3" +
					" and p3.id_level2 = p2.id_level2" +
					" and p2.id_level1 = p1.id_level1" +
					" and p1.id_level1 = p.id_project" +
					" and ft.id_end_time = -1" +
					" and ft.test_result IS NOT null"+closure;

			System.out.println("query: " +query);
			System.out.println("query2: " +query2);


			stmt = dbConnection.prepareStatement(query);

			stmt2 = dbConnection.prepareStatement(query2);



			stmt.execute();
			rs = stmt.executeQuery();
			if (rs.next()) {
				testWithBugs= rs.getBigDecimal("TestWithBugs");
			}


			stmt2.execute();
			rs = stmt2.executeQuery();
			if (rs.next()) {
				testExec = rs.getBigDecimal("TestExec");
			}

			totalValue=java.math.BigDecimal.valueOf((testWithBugs.intValue()*100)/(testExec.intValue()));
	
	
		} catch (Exception e) {
			throw new JRScriptletException(e);
		}
		if (totalValue == null) totalValue = BigDecimal.valueOf(0);
		return totalValue;
	}


}
